Fix up configure problems in xfstests and xfsprogs.
[xfstests-dev.git] / aclocal.m4
1 # aclocal.m4 generated automatically by aclocal 1.6.3 -*- Autoconf -*-
2
3 # Copyright 1996, 1997, 1998, 1999, 2000, 2001, 2002
4 # Free Software Foundation, Inc.
5 # This file is free software; the Free Software Foundation
6 # gives unlimited permission to copy and/or distribute it,
7 # with or without modifications, as long as this notice is preserved.
8
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY, to the extent permitted by law; without
11 # even the implied warranty of MERCHANTABILITY or FITNESS FOR A
12 # PARTICULAR PURPOSE.
13
14
15 # Generic macro, sets up all of the global packaging variables.
16 # The following environment variables may be set to override defaults:
17 #   DEBUG OPTIMIZER MALLOCLIB PLATFORM DISTRIBUTION INSTALL_USER INSTALL_GROUP
18 #   BUILD_VERSION
19 #
20 AC_DEFUN([AC_PACKAGE_GLOBALS],
21   [ pkg_name="$1"
22     AC_SUBST(pkg_name)
23
24     . ./VERSION
25     pkg_version=${PKG_MAJOR}.${PKG_MINOR}.${PKG_REVISION}
26     AC_SUBST(pkg_version)
27     pkg_release=$PKG_BUILD
28     test -z "$BUILD_VERSION" || pkg_release="$BUILD_VERSION"
29     AC_SUBST(pkg_release)
30
31     DEBUG=${DEBUG:-'-DDEBUG'}           dnl  -DNDEBUG
32     debug_build="$DEBUG"
33     AC_SUBST(debug_build)
34
35     OPTIMIZER=${OPTIMIZER:-'-g'}        dnl  -O2
36     opt_build="$OPTIMIZER"
37     AC_SUBST(opt_build)
38
39     MALLOCLIB=${MALLOCLIB:-''}          dnl  /usr/lib/libefence.a
40     malloc_lib="$MALLOCLIB"
41     AC_SUBST(malloc_lib)
42
43     PKG_USER=${INSTALL_USER:-'root'}
44     pkg_user="$PKG_USER"
45     AC_SUBST(pkg_user)
46
47     PKG_GROUP=${INSTALL_GROUP:-'root'}
48     pkg_group="$PKG_GROUP"
49     AC_SUBST(pkg_group)
50
51     pkg_distribution=`uname -s`
52     test -z "$DISTRIBUTION" || pkg_distribution="$DISTRIBUTION"
53     AC_SUBST(pkg_distribution)
54
55     pkg_platform=`uname -s | tr 'A-Z' 'a-z' | sed -e 's/irix64/irix/'`
56     test -z "$PLATFORM" || pkg_platform="$PLATFORM"
57     AC_SUBST(pkg_platform)
58   ])
59
60 #
61 # Check for specified utility (env var) - if unset, fail.
62
63 AC_DEFUN([AC_PACKAGE_NEED_UTILITY],
64   [ if test -z "$2"; then
65         echo
66         echo FATAL ERROR: $3 does not seem to be installed.
67         echo $1 cannot be built without a working $4 installation.
68         exit 1
69     fi
70   ])
71
72 #
73 # Generic macro, sets up all of the global build variables.
74 # The following environment variables may be set to override defaults:
75 #  CC MAKE LIBTOOL TAR ZIP MAKEDEPEND AWK SED ECHO SORT
76 #  MSGFMT MSGMERGE RPM
77 #
78 AC_DEFUN([AC_PACKAGE_UTILITIES],
79   [ AC_PROG_CC
80     cc="$CC"
81     AC_SUBST(cc)
82     AC_PACKAGE_NEED_UTILITY($1, "$cc", cc, [C compiler])
83
84     if test -z "$MAKE"; then
85         AC_PATH_PROG(MAKE, gmake,, /usr/bin:/usr/freeware/bin)
86     fi
87     if test -z "$MAKE"; then
88         AC_PATH_PROG(MAKE, make,, /usr/bin)
89     fi
90     make=$MAKE
91     AC_SUBST(make)
92     AC_PACKAGE_NEED_UTILITY($1, "$make", make, [GNU make])
93
94     if test -z "$LIBTOOL"; then
95         AC_PATH_PROG(LIBTOOL, glibtool,, /usr/bin)
96     fi
97     if test -z "$LIBTOOL"; then
98         AC_PATH_PROG(LIBTOOL, libtool,, /usr/bin:/usr/local/bin:/usr/freeware/bin)
99     fi
100     libtool=$LIBTOOL
101     AC_SUBST(libtool)
102     AC_PACKAGE_NEED_UTILITY($1, "$libtool", libtool, [GNU libtool])
103
104     if test -z "$TAR"; then
105         AC_PATH_PROG(TAR, tar,, /usr/freeware/bin:/bin:/usr/local/bin:/usr/bin)
106     fi
107     tar=$TAR
108     AC_SUBST(tar)
109     if test -z "$ZIP"; then
110         AC_PATH_PROG(ZIP, gzip,, /bin:/usr/local/bin:/usr/freeware/bin)
111     fi
112
113     zip=$ZIP
114     AC_SUBST(zip)
115
116     if test -z "$MAKEDEPEND"; then
117         AC_PATH_PROG(MAKEDEPEND, makedepend, /bin/true)
118     fi
119     makedepend=$MAKEDEPEND
120     AC_SUBST(makedepend)
121
122     if test -z "$AWK"; then
123         AC_PATH_PROG(AWK, awk,, /bin:/usr/bin)
124     fi
125     awk=$AWK
126     AC_SUBST(awk)
127
128     if test -z "$SED"; then
129         AC_PATH_PROG(SED, sed,, /bin:/usr/bin)
130     fi
131     sed=$SED
132     AC_SUBST(sed)
133
134     if test -z "$ECHO"; then
135         AC_PATH_PROG(ECHO, echo,, /bin:/usr/bin)
136     fi
137     echo=$ECHO
138     AC_SUBST(echo)
139
140     if test -z "$SORT"; then
141         AC_PATH_PROG(SORT, sort,, /bin:/usr/bin)
142     fi
143     sort=$SORT
144     AC_SUBST(sort)
145
146     dnl check if symbolic links are supported
147     AC_PROG_LN_S
148
149     if test "$enable_gettext" = yes; then
150         if test -z "$MSGFMT"; then
151                 AC_PATH_PROG(MSGFMT, msgfmt,, /usr/bin:/usr/freeware/bin)
152         fi
153         msgfmt=$MSGFMT
154         AC_SUBST(msgfmt)
155         AC_PACKAGE_NEED_UTILITY($1, "$msgfmt", msgfmt, gettext)
156
157         if test -z "$MSGMERGE"; then
158                 AC_PATH_PROG(MSGMERGE, msgmerge,, /usr/bin:/usr/freeware/bin)
159         fi
160         msgmerge=$MSGMERGE
161         AC_SUBST(msgmerge)
162         AC_PACKAGE_NEED_UTILITY($1, "$msgmerge", msgmerge, gettext)
163     fi
164
165     if test -z "$RPM"; then
166         AC_PATH_PROG(RPM, rpm,, /bin:/usr/bin:/usr/freeware/bin)
167     fi
168     rpm=$RPM
169     AC_SUBST(rpm)
170
171     dnl .. and what version is rpm
172     rpm_version=0
173     test -x "$RPM" && rpm_version=`$RPM --version \
174                         | awk '{print $NF}' | awk -F. '{V=1; print $V}'`
175     AC_SUBST(rpm_version)
176     dnl At some point in rpm 4.0, rpm can no longer build rpms, and
177     dnl rpmbuild is needed (rpmbuild may go way back; not sure)
178     dnl So, if rpm version >= 4.0, look for rpmbuild.  Otherwise build w/ rpm
179     if test $rpm_version -ge 4; then
180         AC_PATH_PROG(RPMBUILD, rpmbuild)
181         rpmbuild=$RPMBUILD
182     else
183         rpmbuild=$RPM
184     fi
185     AC_SUBST(rpmbuild)
186   ])
187
188 AC_DEFUN([AC_PACKAGE_NEED_UUID_H],
189   [ AC_CHECK_HEADERS(uuid.h)
190     if test $ac_cv_header_uuid_h = no; then
191         AC_CHECK_HEADERS(uuid/uuid.h,, [
192         echo
193         echo 'FATAL ERROR: could not find a valid UUID header.'
194         echo 'Install the Universally Unique Identifiers development package.'
195         exit 1])
196     fi
197   ])
198
199 AC_DEFUN([AC_PACKAGE_NEED_UUIDCOMPARE],
200   [ AC_CHECK_FUNCS(uuid_compare)
201     if test $ac_cv_func_uuid_compare = yes; then
202         libuuid=""
203     else
204         AC_CHECK_LIB(uuid, uuid_compare,, [
205             echo
206             echo 'FATAL ERROR: could not find a valid UUID library.'
207             echo 'Install the Universally Unique Identifiers library package.'
208             exit 1])
209         libuuid="-luuid"
210     fi
211     AC_SUBST(libuuid)
212   ])
213
214 AC_DEFUN([AC_PACKAGE_NEED_SYS_ACL_H],
215   [ AC_CHECK_HEADERS([sys/acl.h])
216     if test "$ac_cv_header_sys_acl_h" != "yes"; then
217         echo
218         echo 'FATAL ERROR: sys/acl.h does not exist.'
219         echo 'Install the access control lists (acl) development package.'
220         echo 'Alternatively, run "make install-lib" from the acl source.'
221         exit 1
222     fi
223   ])
224
225 AC_DEFUN([AC_PACKAGE_NEED_ACL_LIBACL_H],
226   [ AC_CHECK_HEADERS([acl/libacl.h])
227     if test "$ac_cv_header_acl_libacl_h" != "yes"; then
228         echo
229         echo 'FATAL ERROR: acl/libacl.h does not exist.'
230         echo 'Install the access control lists (acl) development package.'
231         echo 'Alternatively, run "make install-lib" from the acl source.'
232         exit 1
233     fi
234   ])
235
236
237 AC_DEFUN([AC_PACKAGE_NEED_ACLINIT_LIBACL],
238   [ AC_CHECK_LIB(acl, acl_init,, [
239         echo
240         echo 'FATAL ERROR: could not find a valid Access Control List library.'
241         echo 'Install either the libacl (rpm) or the libacl1 (deb) package.'
242         echo 'Alternatively, run "make install-lib" from the acl source.'
243         exit 1
244     ])
245     libacl="-lacl"
246     test -f `pwd`/../acl/libacl/libacl.la && \
247         libacl="`pwd`/../acl/libacl/libacl.la"
248     test -f /usr/lib/libacl.la && libacl="/usr/lib/libacl.la"
249     AC_SUBST(libacl)
250   ])
251
252 AC_DEFUN([AC_PACKAGE_WANT_NDBM],
253   [ AC_CHECK_HEADERS(ndbm.h, [ have_db=true ], [ have_db=false ])
254     libgdbm=""
255     AC_SUBST(libgdbm)
256     AC_SUBST(have_db)
257   ])
258
259 AC_DEFUN([AC_PACKAGE_WANT_GDBM],
260   [ AC_CHECK_HEADERS([gdbm/ndbm.h], [ have_db=true ], [ have_db=false ])
261     if test $have_db = true -a -f /usr/lib/libgdbm.a; then
262         libgdbm="/usr/lib/libgdbm.a"
263     fi
264     AC_SUBST(libgdbm)
265     AC_SUBST(have_db)
266   ])
267
268 AC_DEFUN([AC_PACKAGE_NEED_XFS_LIBXFS_H],
269   [ AC_CHECK_HEADERS([xfs/libxfs.h])
270     if test "$ac_cv_header_xfs_libxfs_h" != "yes"; then
271         echo
272         echo 'FATAL ERROR: cannot find a valid <xfs/libxfs.h> header file.'
273         echo 'Install or upgrade the XFS development package.'
274         echo 'Alternatively, run "make install-dev" from the xfsprogs source.'
275         exit 1
276     fi
277   ])
278
279 AC_DEFUN([AC_PACKAGE_NEED_XFS_XQM_H],
280   [ AC_CHECK_HEADERS([xfs/xqm.h])
281     if test "$ac_cv_header_xfs_xqm_h" != "yes"; then
282         echo
283         echo 'FATAL ERROR: cannot find a valid <xfs/xqm.h> header file.'
284         echo 'Install or upgrade the XFS development package.'
285         echo 'Alternatively, run "make install-dev" from the xfsprogs source.'
286         exit 1
287     fi
288   ])
289
290 AC_DEFUN([AC_PACKAGE_NEED_XFS_HANDLE_H],
291   [ AC_CHECK_HEADERS([xfs/handle.h])
292     if test "$ac_cv_header_xfs_handle_h" != "yes"; then
293         echo
294         echo 'FATAL ERROR: cannot find a valid <xfs/handle.h> header file.'
295         echo 'Install or upgrade the XFS development package.'
296         echo 'Alternatively, run "make install-dev" from the xfsprogs source.'
297         exit 1
298     fi
299   ])
300
301 AC_DEFUN([AC_PACKAGE_NEED_LIBXFSINIT_LIBXFS],
302   [ AC_CHECK_LIB(xfs, libxfs_init,, [
303         echo
304         echo 'FATAL ERROR: could not find a valid XFS base library.'
305         echo 'Install or upgrade the XFS library package.'
306         echo 'Alternatively, run "make install-dev" from the xfsprogs source.'
307         exit 1
308     ])
309     libxfs="-lxfs"
310     test -f `pwd`/../xfsprogs/libxfs/libxfs.la && \
311         libxfs="`pwd`/../xfsprogs/libxfs/libxfs.la"
312     test -f /usr/lib/libxfs.la && libxfs="/usr/lib/libxfs.la"
313     AC_SUBST(libxfs)
314   ])
315
316 AC_DEFUN([AC_PACKAGE_NEED_OPEN_BY_FSHANDLE],
317   [ AC_CHECK_LIB(handle, open_by_fshandle,, [
318         echo
319         echo 'FATAL ERROR: could not find a current XFS handle library.'
320         echo 'Install or upgrade the XFS library package.'
321         echo 'Alternatively, run "make install-dev" from the xfsprogs source.'
322         exit 1
323     ])
324     libhdl="-lhandle"
325     test -f `pwd`/../xfsprogs/libhandle/libhandle.la && \
326         libhdl="`pwd`/../xfsprogs/libhandle/libhandle.la"
327     test -f /usr/lib/libhandle.la && libhdl="/usr/lib/libhandle.la"
328     AC_SUBST(libhdl)
329   ])
330
331 AC_DEFUN([AC_PACKAGE_NEED_XFSCTL_MACRO],
332   [ AC_MSG_CHECKING([xfsctl from xfs/libxfs.h])
333     AC_TRY_LINK([#include <xfs/libxfs.h>], [ int x = xfsctl(0, 0, 0, 0); ],
334       [ echo ok ],
335       [ echo
336         echo 'FATAL ERROR: cannot find required macros in the XFS headers.'
337         echo 'Upgrade your XFS programs (xfsprogs) development package.'
338         echo 'Alternatively, run "make install-dev" from the xfsprogs source.'
339         exit 1
340       ])
341   ])
342
343 AC_DEFUN([AC_PACKAGE_NEED_ATTR_XATTR_H],
344   [ AC_CHECK_HEADERS([attr/xattr.h])
345     if test "$ac_cv_header_attr_xattr_h" != "yes"; then
346         echo
347         echo 'FATAL ERROR: attr/xattr.h does not exist.'
348         echo 'Install the extended attributes (attr) development package.'
349         echo 'Alternatively, run "make install-lib" from the attr source.'
350         exit 1
351     fi
352   ])
353
354 AC_DEFUN([AC_PACKAGE_NEED_ATTR_ERROR_H],
355   [ AC_CHECK_HEADERS([attr/error_context.h])
356     if test "$ac_cv_header_attr_error_context_h" != "yes"; then
357         echo
358         echo 'FATAL ERROR: attr/error_context.h does not exist.'
359         echo 'Install the extended attributes (attr) development package.'
360         echo 'Alternatively, run "make install-lib" from the attr source.'
361         exit 1
362     fi
363   ])
364
365 AC_DEFUN([AC_PACKAGE_NEED_ATTR_ATTRIBUTES_H],
366   [ AC_CHECK_HEADERS([attr/attributes.h])
367     if test "$ac_cv_header_attr_attributes_h" != "yes"; then
368         echo
369         echo 'FATAL ERROR: attr/attributes.h does not exist.'
370         echo 'Install the extended attributes (attr) development package.'
371         echo 'Alternatively, run "make install-lib" from the attr source.'
372         exit 1
373     fi
374   ])
375
376 AC_DEFUN([AC_PACKAGE_NEED_GETXATTR_LIBATTR],
377   [ AC_CHECK_LIB(attr, getxattr,, [
378         echo
379         echo 'FATAL ERROR: could not find a valid Extended Attributes library.'
380         echo 'Install the extended attributes (attr) development package.'
381         echo 'Alternatively, run "make install-lib" from the attr source.'
382         exit 1
383     ])
384     libattr="-lattr"
385     test -f `pwd`/../attr/libattr/libattr.la && \
386         libattr="`pwd`/../attr/libattr/libattr.la"
387     test -f /usr/lib/libattr.la && libattr="/usr/lib/libattr.la"
388     AC_SUBST(libattr)
389   ])
390
391 AC_DEFUN([AC_PACKAGE_NEED_ATTRGET_LIBATTR],
392   [ AC_CHECK_LIB(attr, attr_get,, [
393         echo
394         echo 'FATAL ERROR: could not find a valid Extended Attributes library.'
395         echo 'Install the extended attributes (attr) development package.'
396         echo 'Alternatively, run "make install-lib" from the attr source.'
397         exit 1
398     ])
399     libattr="-lattr"
400     test -f `pwd`/../attr/libattr/libattr.la && \
401         libattr="`pwd`/../attr/libattr/libattr.la"
402     test -f /usr/lib/libattr.la && libattr="/usr/lib/libattr.la"
403     AC_SUBST(libattr)
404   ])
405
406 AC_DEFUN([AC_PACKAGE_NEED_ATTRIBUTES_MACROS],
407   [ AC_MSG_CHECKING([macros in attr/attributes.h])
408     AC_TRY_LINK([
409 #include <sys/types.h>
410 #include <attr/attributes.h>],
411     [ int x = ATTR_SECURE; ], [ echo ok ], [
412         echo
413         echo 'FATAL ERROR: could not find a current attributes header.'
414         echo 'Upgrade the extended attributes (attr) development package.'
415         echo 'Alternatively, run "make install-dev" from the attr source.'
416         exit 1 ])
417   ])
418